import { Element, ElementAttributes } from '@lume/element';
import { JSXElement } from 'solid-js';
import { Grammar, Theme } from './tm';

/**********************************************************************************/
/**********************************************************************************/
interface TmTextareaAttributes extends Omit<ElementAttributes<TmTextareaElement, 'grammar' | 'theme' | 'editable'>, 'onInput' | 'oninput'> {
    oninput?: (event: InputEvent & {
        currentTarget: TmTextareaElement;
    }) => any;
    onInput?: (event: InputEvent & {
        currentTarget: TmTextareaElement;
    }) => any;
    value: string;
}
declare module 'solid-js/jsx-runtime' {
    namespace JSX {
        interface IntrinsicElements {
            'tm-textarea': TmTextareaAttributes;
        }
    }
}
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'tm-textarea': TmTextareaAttributes;
        }
    }
}
export declare class TmTextareaElement extends Element {
    #private;
    shadowOptions: {
        mode: "open";
        serializable: boolean;
    };
    editable: boolean;
    grammar: Grammar;
    stylesheet: string;
    theme: Theme;
    value: string;
    textarea: HTMLTextAreaElement;
    jsx: JSXElement | undefined;
    constructor();
    template: () => import("@lume/element").JSX.Element;
    get selectionStart(): number;
    set selectionStart(start: number);
    get selectionEnd(): number;
    set selectionEnd(end: number);
    setRangeText(replacement: string, start?: number, end?: number, selectMode?: 'select' | 'start' | 'end' | 'preserve'): void;
    setSelectionRange(selectionStart: number, selectionEnd: number, selectionDirection?: 'forward' | 'backward' | 'none'): void;
    select(): void;
}
export declare function register(): void;
export {};
